//
// Created by robin on 5/10/16.
//

#ifndef ROZITM_PCAP_H
#define ROZITM_PCAP_H

#include <string>
#include <functional>
#include <pcap.h>
#include "DBO/Result.h"

typedef std::function<bool(void* userData, unsigned int len, const char* data)> PcapCallback;

class Pcap
{
public:
    Pcap(const std::string& device);
    ~Pcap();

    ResultBool init(int snaplen = BUFSIZ, bool promisc = true, int timeout = 1000);

    ResultBool run(PcapCallback callback, void* data = 0, int count = -1);

    ResultBool send(void* data, unsigned int len);

    void stop();

    void close();

    std::string getPcapLastError() const;

    static ResultString getDefaultDevice();

protected:
    const std::string _device;

    pcap_t* _pcap;

    bool _isInLoop;

    void onPacket(u_char *args, const struct pcap_pkthdr *header, const u_char *packet);
};


#endif //ROZITM_PCAP_H
